/*  Copyright (C) 1998-2002 Jason Lango
 *
 *  This file is part of the Doors for Linux User Library.
 * 
 *  The Doors for Linux User Library is free software; you can
 *  redistribute it and/or modify it under the terms of the GNU Lesser
 *  General Public License as published by the Free Software
 *  Foundation; either version 2.1 of the License, or (at your option)
 *  any later version.
 *
 *  The Doors for Linux User Library is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY; without even the
 *  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE.  See the GNU Lesser General Public License for more
 *  details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with the Doors for Linux User Library; if not, write
 *  to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA  02111-1307  USA
 */

/*
 * door_info.c
 * Jason Lango <jal@rampant.org>
 */

#include "door.h"
#include "door_ioctl.h"
#include "libdoor.h"
#include <sys/ioctl.h>

int __door_info(int d, struct door_info *info)
{
	struct door_info_args args;

	DOOR_INIT();

	args.fd = d;
	args.info = DOOR_PTR(info);

	return __ioctl(__door_dev_fd, DOOR_INFO, &args);
}

weak_alias(__door_info, door_info)
