/*  Copyright (C) 1998-2002 Jason Lango
 *
 *  This file is part of the Doors for Linux Kernel Module.
 * 
 *  The Doors for Linux Kernel Module is free software; you can
 *  redistribute it and/or modify it under the terms of the GNU
 *  General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or (at your option)
 *  any later version.
 *
 *  The Doors for Linux Kernel Module is distributed in the hope that
 *  it will be useful, but WITHOUT ANY WARRANTY; without even the
 *  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *  PURPOSE.  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with the Doors for Linux Kernel Module; if not, write to the
 *  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 *  Boston, MA  02111-1307  USA
 */

/*
 *  vm_copy.h - Copy-on-write an address range between processes.
 *  Jason Lango <jal@rampant.org>
 */

struct mm_struct;

/*
 * door_vm_copy
 *
 *	Does a copy-on-write copy of the address range
 *	[src_addr, src_addr + src_len) from mm_src into a newly mapped
 *	address range in mm_dst.
 *
 *	Optionally, allocates normal memory in the range
 *	[addr + src_len, addr + src_len + alloc_len) if alloc_len is non-zero.
 */

int door_vm_copy(struct task_struct *tsk_dst, struct task_struct *tsk_src,
	unsigned long src_addr, unsigned long src_len, unsigned long alloc_len,
	unsigned long *addr);
